#include "kanji_union.h"

extern SJIS_TABLE *u;
extern KANJI *double_byte_character;

static int ERROR_CODE = 1;

int standard_input_output(REGULATE *r) {
    BOOL *which = & r->which_table;
    BOOL kanji = FALSE;
    char *p;
    char a[3] = {0, 0, 0};
    int c, k, m;
    int exit_code = 0;
    unsigned char uc;
    unsigned char first_byte = 0x40;

    if(! setting(u, r->no_searching, which) ) {
        error_handler("standard_input_output() error:", "setting(u, r->no_searching, which)");
        return ERROR_CODE;
    }

    for(;;) {
        p = fgets(r->buffer, BUFFER_SIZE, stdin);
        if(p == NULL) {
            break;
        }

        k = 0;
        for(m = 0; r->buffer[m]; m++) {
            uc = (unsigned char)r->buffer[m];
            c = (int)uc;

            if(kanji) {
                a[0] = (char)first_byte;
                a[1] = uc;
                r->combo[k] = working(u, inverted(a), 0);
                r->combo[ k + 1 ] = working(u, inverted(a), 1);
                k += SJIS_KANJI_SIZE;
                kanji = FALSE;
                continue;
            }

            if(0x81 <= c && c<= 0xFC) {
                if(KANA_KUTEN <= c && c <= KANA_HANDAKUTEN) {
                    r->combo[k] = working(u, c, 0);
                    k += KATAKANA_SIZE;
                    kanji = FALSE;
                } else {
                    first_byte = uc;
                    kanji = TRUE;
                }

            } else {
                r->combo[k++] = (char)uc;
                kanji = FALSE;
            }

        }

        r->combo[k] = '\0';
        fputs(r->combo, stdout);
    }

    detach_table(u);
    release_buffers(r);
    return exit_code;
}

